import type { AstroConfig } from '../@types/astro-core';
import type { ErrorPayload } from 'vite';
/** Normalize URL to its canonical form */
export declare function canonicalURL(url: string, base?: string): URL;
/** is a specifier an npm package? */
export declare function parseNpmName(spec: string): {
    scope?: string;
    name: string;
    subpath?: string;
} | undefined;
/** generate code frame from esbuild error */
export declare function codeFrame(src: string, loc: ErrorPayload['err']['loc']): string;
export declare function resolveDependency(dep: string, astroConfig: AstroConfig): string;
